<?php
/**
* MyMiniCity View Function for Geeklog Ver 1.0.0 2008/01/01
*
* @authors dengen (Yoshinori Tahara) - taharaxp AT gmail DOT com
*
* @caution 1. このスクリプトはUTF-8で書かれています。EUC-JPで使う場合は，EUC-JP
*            で保存し直してください。
*/

//=====================================
//  Configurations
//=====================================

// あなたのユーザ名を設定してください。
$myminicity_username = 'dengen';

// 表示幅を設定してください。
$myminicity_width = 200;

// 訪問者を誘うコメントを設定してください。
$myminicity_message = 'Please come in MyMiniCity!';


//=====================================
//  Functions
//=====================================
require_once('HTTP/Request.php');

function phpblock_myminicity( $caltype = 1 )
{
    global $myminicity_username, $myminicity_width, $myminicity_message;

    $height = intval($myminicity_width * 2 / 3);
    $ua = $_SERVER['HTTP_USER_AGENT'];

//  $referrer はどっちが適正なんだろう？
//  $referrer = COM_getCurrentURL();
    $referrer = $_SERVER['HTTP_REFERER'];

    $url = 'http://' . $myminicity_username . '.myminicity.com/';

    //オブジェクト生成
    $req =& new HTTP_Request($url);

    //UA
    $req->addHeader('User-Agent', $ua);

    //リクエストメソッド
    $req->setMethod(HTTP_REQUEST_METHOD_GET);

    //クッキー
    $req->addCookie("X-MV-referrer", $referrer);
    $req->addCookie("X-Ref-Ok", "1");

    //リクエスト送信
    $req->sendRequest();

    //レスポンス取得
    $res = $req->getResponseBody();

    $display = '';
    if ( preg_match( '/"name=.*?&k=.*?"/', $res, $match ) ) {
        $param = str_replace ( '&', '&amp;', $match[0] );
        $display = '<embed width="' . $myminicity_width . '" height="' . $height . '" flashvars=' . $param
                 . ' allowscriptaccess="always" menu="false" quality="high" bgcolor="#deecfe" '
                 . 'name="client" id="client" src="http://data.myminicity.com/swf/client.swf?v=0" '
                 . 'type="application/x-shockwave-flash">' . LB
                 . '<p><a href="' . $url . '">'
                 . $myminicity_message . '</a></p>' . LB;
    }

    return $display;
}
?>
